#include <pthread.h>
#include <stdio.h>    // printf
#include <unistd.h>   // sleep



#define MAX_WORKERS 10

int i;

void *worker (void *args) {
  int i;
  sleep (1);
  char c = (int)args;
  for (i=0; i<10; i++) {
    printf ("%c", c); fflush (0);
    sched_yield ();
  }
  return NULL;
}

int main () {
  printf ("--Start--\n");

  pthread_t threads[MAX_WORKERS];
  
  int i;
  for (i=0; i<MAX_WORKERS; i++)
    pthread_create (&threads[i], NULL, worker, (void*)(i+'A'));
  for (i=0; i<MAX_WORKERS; i++)
    pthread_join (threads[i], NULL);
  printf ("\n--Fertig--\n");
  return 0;
}
