#include <stdio.h>      // printf
#include <unistd.h>     // sleep
#include <sys/types.h>  // waitpid
#include <sys/wait.h>   // waitpid
#include <sched.h>      // sched_yield

#define MAX_WORKERS 10

int i;

void *worker (void *args) {
  int i;
  sleep (1);
  char c = (int)args;
  for (i=0; i<10; i++) {
    printf ("%c", c); fflush (0);
    sched_yield ();
  }
  return NULL;
}

int main () {
  printf ("--Start--\n");

  int pids[MAX_WORKERS];
  
  int i;
  for (i=0; i<MAX_WORKERS; i++) {
    pids[i] = fork ();
    if (pids[i] == 0) {
      // Sohn...
      worker ((void*)(i+'A'));
      return 0;
    }
  }

  for (i=0; i<MAX_WORKERS; i++)
    waitpid (pids[i], NULL, 0);
  printf ("\n--Fertig--\n");
  return 0;
}
